/* Problem URL: https://codeforces.com/problemset/problem/2184/E */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    cin >> n;
    vi p(n);
    cin >> p;

    vi diff(n - 1);
    nrep(i, 1, n) {
        diff[i - 1] = abs(p[i] - p[i - 1]);
    }

    vvi sparse(20, vi(n - 1));
    rep(i, n - 1) {
        sparse[0][i] = diff[i];
    }

    nrep(j, 1, 20) {
        for (int i = 0; i + (1 << (j - 1)) < n - 1; i++) {
            sparse[j][i] = min(sparse[j - 1][i], sparse[j - 1][i + (1 << (j - 1))]);
        }
    }

    auto query = [&](int l, int r) {
        int log = 31 - __builtin_clz(r - l + 1);
        return min(sparse[log][l], sparse[log][r - (1 << log) + 1]);
    };

    vl ans(n + 1);
    vi lim(n + 1, -1);

    rep(i, n - 1) {
        int low = i;
        int high = n - 2;
        int r = i;
        while (low <= high) {
            int mid = (low + high) >> 1;

            int q = query(i, mid);
            if (q == diff[i]) {
                r = mid;
                low = mid + 1;
                continue;
            }

            high = mid - 1;
        }

        low = lim[diff[i]] + 1;
        high = i;
        int l = i;
        while (low <= high) {
            int mid = (low + high) >> 1;

            int q = query(mid, i);
            if (q == diff[i]) {
                l = mid;
                high = mid - 1;
                continue;
            }

            low = mid + 1;
        }

        ll act = (ll)(i - l + 1) * (ll)(r - i + 1);
        ans[0] += act;
        ans[diff[i] + 1] -= act;
        lim[diff[i]] = i;
    }

    nrep(i, 1, n) {
        ans[i] += ans[i - 1];
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
